#include <iostream>
#include <cmath>
#include <array>
using namespace std;

void sredi(long vodopad[], long protok[], long red) {
    long zbir=0;
    long prvi=0;
    long poslednji=0;
    int k=0;
    int i=0;
    while (i<protok.length()) {
        if (vodopad[i]==1) {
            i++;
            continue;
        }
        else {
            prvi=i;
            k=i;
            while (k<protok.length()&&vodopad[k]==0) {
                zbir=zbir+protok[k];
                protok[k]=0;
                k++;
            }
            poslednji = k-1;
            if (prvi==0) {
                protok[poslednji+1]+=zbir;
            }
            else if (poslednji==protok.length()-1) {
                protok[prvi-1]+=zbir;
            }
            else if (zbir%2==0) {
                protok[prvi-1]+=zbir/2;
                protok[poslednji+1]+=zbir/2;
            }
            else if (red%2==1){
                protok[prvi-1]+=zbir/2+1;
                protok[poslednji+1]+=zbir/2;
            }
            else {
                protok[prvi-1]+=zbir/2;
                protok[poslednji+1]+=zbir/2+1;
            }
            zbir=0;
            i=poslednji+1;
        }
    }    
}
int main() {
    long h;
    long n;
    long vodopad[h][n];
    long protok[n];
    scanf("%d %d",&h,&n);
    for (int i=0;i<h;i++) {
        for (int k=0;k<n;k++) {
            scanf("%d",&vodopad[i][k]);
        }
    }
    for(int p=0; p<h; p++) {
        sredi (vodopad[p], protok, p+1);
    }
    for (int f=0;f<n;f++) {
        printf("%d",protok[f]);
    }
    return 0;
}